﻿'
'   PCI-9016调试软件(VB.NET)
'   Date: 2019/6
'

'是否使用LEGACY API
'#Const USE_LEGACY_API = True

Imports System.Runtime.InteropServices
Public Class Form1
    Public g_AppVersionStr As String = "0x0106"    '应用程序版本号
    Public MOT_AXIS_MAX As Integer = 64
    Public MOT_MAX_DIO As Integer = 16
    Public AXES_PER_DEV As Integer = 6

    Private m_din(MOT_MAX_DIO - 1) As Integer
    Private m_dout(MOT_MAX_DIO - 1) As Integer

    Private m_AxisJogPos1(MOT_AXIS_MAX - 1) As Integer
    Private m_AxisJogPos2(MOT_AXIS_MAX - 1) As Integer      'target2 for repeat mode
    Private m_AxisRepeatMove(MOT_AXIS_MAX - 1) As Boolean
    Private m_cardIds(15) As Integer
    Private m_cardCount As Integer
    Private m_curCardNo As Integer

#Region "窗口初始化与关闭"
    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim i, rc, axis As Integer
        For i = 0 To MOT_MAX_DIO - 1
            m_din(i) = 1
        Next

        For i = 0 To MOT_AXIS_MAX - 1
            m_AxisJogPos1(i) = 0
            m_AxisJogPos2(i) = 20000
        Next

        dgrdAxisStatus.Rows.Add()
        dgrdAxisStatus.Rows.Add()
        dgrdAxisStatus.Rows.Add()
        dgrdAxisStatus.Rows.Add()
        dgrdAxisStatus.Rows.Add()
        dgrdAxisStatus.Rows.Add()

        dgrdAxisStatus.Rows(0).HeaderCell.Value = "X"
        dgrdAxisStatus.Rows(1).HeaderCell.Value = "Y"
        dgrdAxisStatus.Rows(2).HeaderCell.Value = "Z"
        dgrdAxisStatus.Rows(3).HeaderCell.Value = "A"
        dgrdAxisStatus.Rows(4).HeaderCell.Value = "B"
        dgrdAxisStatus.Rows(5).HeaderCell.Value = "C"

        dgrdAxisStatus.RowHeadersWidth() = 65
        dgrdAxisStatus.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight
        For i = 0 To dgrdAxisStatus.ColumnCount() - 1
            dgrdAxisStatus.Columns(i).SortMode = DataGridViewColumnSortMode.NotSortable
        Next

        Timer1.Enabled = True

        NcConfig.Load()

        rc = p9016_initial(m_cardCount, m_cardIds)
        If rc <> 0 Then
            MsgBox("控制卡初始化失败！(" & rc.ToString() & ")", MsgBoxStyle.Information, "错误提示")
            Application.Exit()
        End If

        If m_cardCount < 1 Then
            MsgBox("找不到控制卡！", MsgBoxStyle.Information, "错误提示")
            Application.Exit()
        Else
            For i = 0 To m_cardCount - 1
                'CbCardNo.Items.Add(m_cardIds(i).ToString())

                'config axis according to ncconfig
                For axis = m_cardIds(i) * AXES_PER_DEV + 0 To m_cardIds(i) * AXES_PER_DEV + AXES_PER_DEV - 1
                    ConfigAxis(axis)

                    '为伺服使能设置初始值
                    'p9016_axis_set_servo_on(axis, NcConfig.AxisServoON(axis))
                Next

                '将查找到的卡号添加到菜单项中
                ToolStripMenuItemDevSel.DropDownItems.Add(i.ToString(), Nothing, AddressOf ToolStripMenuItemDevSel_Click).Name = i.ToString()
            Next
            'CbCardNo.SelectedIndex = 0
            m_curCardNo = m_cardIds(0)
            Me.Text = "PCI-9016#" + m_curCardNo.ToString()

            'update content of axis/dio/cfg page
            AxisUpdateDlg()
            CfgUpateDlg()
            UpdateDio()
        End If

    End Sub

    Private Sub Form1_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        p9016_close()
    End Sub
#End Region

#Region "定时器事件处理"
    ''' <summary>
    ''' 定时器函数处理界面内容刷新
    ''' </summary>
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Dim axis, row, rc As Integer
        Dim Ver(0 To 3) As UInteger
        Dim info(0 To 7) As UInteger
        Dim i As Integer
        Dim dout As UInteger
        Dim cmdPos, actPos, inpos, posHardLimit, negHardLimit, homeSwitch, fault, abort As Integer
        Dim stat As UInteger
        Dim cmdVel As Double
        Dim axisStat As MOT_AXIS_STAT
        Dim cmpStat As MOT_CMP_STAT
        Dim err As Integer

        For row = 0 To AXES_PER_DEV - 1
            axis = m_curCardNo * AXES_PER_DEV + row
#If USE_LEGACY_API Then
            rc = p9016_get_pos(axis, 0, cmdPos)
            If rc <> 0 Then
                Return
            End If
            p9016_get_pos(axis, 1, actPos)
            p9016_get_motion_status(axis, stat)
            inpos = IIf(stat = 0, 1, 0)
            p9016_get_current_speed(axis, cmdVel)
            p9016_get_io_status(axis, stat)
            posHardLimit = IIf((stat And &H1) = 0, 0, 1)
            negHardLimit = IIf((stat And &H2) = 0, 0, 1)
            homeSwitch = IIf((stat And &H4) = 0, 0, 1)
            fault = IIf((stat And &H100) = 0, 0, 1)
            abort = IIf((stat And &H10) = 0, 1, 0)        'emg is low active and cannot be configured
            err = 0
            If (posHardLimit <> 0) Or (negHardLimit <> 0) Or (fault <> 0) Then
                err = 1
            End If
#Else

            rc = p9016_axis_get_status(axis, axisStat)
            If rc <> 0 Then
                Return
            End If
            cmdPos = CInt(axisStat.cmdPos)
            cmdVel = axisStat.cmdVel
            actPos = CInt(axisStat.actPos)
            inpos = axisStat.inpos
            posHardLimit = axisStat.posHardLimit
            negHardLimit = axisStat.negHardLimit
            homeSwitch = axisStat.homeSwitch
            fault = axisStat.fault
            abort = axisStat.abort
            err = axisStat.err

            '此处更新位置比较器使用的反馈位置
            If NcConfig.CmpEnable(m_curCardNo) <> 0 And (axis Mod AXES_PER_DEV = NcConfig.CmpRefSource(m_curCardNo)) Then
                TxtCmpActPos.Text = actPos.ToString()
            End If
#End If

            dgrdAxisStatus.Rows(row).Cells(0).Value() = cmdPos.ToString()
            dgrdAxisStatus.Rows(row).Cells(1).Value() = actPos.ToString()
            dgrdAxisStatus.Rows(row).Cells(2).Value() = cmdVel.ToString("f1")
            dgrdAxisStatus.Rows(row).Cells(3).Value() = IIf(inpos <> 0, "Y", "N")
            dgrdAxisStatus.Rows(row).Cells(4).Value() = IIf(posHardLimit <> 0, "Y", "N")
            dgrdAxisStatus.Rows(row).Cells(4).Style.BackColor = IIf(posHardLimit <> 0, Color.Red, Color.White)
            dgrdAxisStatus.Rows(row).Cells(5).Value() = IIf(negHardLimit <> 0, "Y", "N")
            dgrdAxisStatus.Rows(row).Cells(5).Style.BackColor = IIf(negHardLimit <> 0, Color.Red, Color.White)
            dgrdAxisStatus.Rows(row).Cells(6).Value() = IIf(homeSwitch <> 0, "Y", "N")
            dgrdAxisStatus.Rows(row).Cells(7).Value() = IIf(fault <> 0, "Y", "N")
            dgrdAxisStatus.Rows(row).Cells(7).Style.BackColor = IIf(fault <> 0, Color.Red, Color.White)

            dgrdAxisStatus.Rows(row).Cells(8).Value() = IIf(abort <> 0, "Y", "N")
            dgrdAxisStatus.Rows(row).Cells(8).Style.BackColor = IIf(abort <> 0, Color.Red, Color.White)
            'dgrdAxisStatus.Rows(row).Cells(8).Value() = IIf(err <> 0, "Y", "N")
            'dgrdAxisStatus.Rows(row).Cells(8).Style.BackColor = IIf(err <> 0, Color.Red, Color.White)
            'pci-9016 has no dedicated servo-on pin
            'dgrdAxisStatus.Rows(row).Cells(9).Value() = IIf(NcConfig.AxisServoON(axis) <> 0, "Y", "N") 

            '处理控制轴往复运动
            If m_AxisRepeatMove(axis) And inpos <> 0 Then
                If Math.Abs(cmdPos - m_AxisJogPos1(axis)) < 1 Then
#If USE_LEGACY_API Then
                    p9016_set_t_profile(axis, NcConfig.AxisMinVel(axis), NcConfig.AxisMaxVel(axis), NcConfig.AxisAccel(axis), NcConfig.AxisDecel(axis))
                    p9016_pmove(axis, m_AxisJogPos2(axis), 1, 2)
#Else
                    p9016_axis_set_profile(axis, NcConfig.AxisMinVel(axis), NcConfig.AxisMaxVel(axis), NcConfig.AxisAccel(axis), NcConfig.AxisDecel(axis), NcConfig.AxisAccel(axis) * 1000000.0)
                    p9016_axis_abs_move(axis, m_AxisJogPos2(axis))
#End If

                ElseIf Math.Abs(cmdPos - m_AxisJogPos2(axis)) < 1 Then
#If USE_LEGACY_API Then
                    p9016_set_t_profile(axis, NcConfig.AxisMinVel(axis), NcConfig.AxisMaxVel(axis), NcConfig.AxisAccel(axis), NcConfig.AxisDecel(axis))
                    p9016_pmove(axis, m_AxisJogPos2(axis), 1, 2)
#Else
                    p9016_axis_set_profile(axis, NcConfig.AxisMinVel(axis), NcConfig.AxisMaxVel(axis), NcConfig.AxisAccel(axis), NcConfig.AxisDecel(axis), NcConfig.AxisAccel(axis) * 1000000.0)
                    p9016_axis_abs_move(axis, m_AxisJogPos1(axis))
#End If
                End If
            End If
        Next

        'update DI/DO
        stat = 0
#If USE_LEGACY_API Then
        p9016_get_di(m_curCardNo, stat)     '该接口读出的DIN状态，0表示导通（低电平），1表示截止（高电平）
        For i = 0 To MOT_MAX_DIO - 1
            m_din(i) = IIf((stat And (&H1 << i)) = 0, 1, 0)
        Next
#Else
        p9016_motion_get_din_ex(m_curCardNo, stat)  '该接口读出的DIN状态，1表示导通，0表示截止
        For i = 0 To MOT_MAX_DIO - 1
            m_din(i) = IIf((stat And (&H1 << i)) <> 0, 1, 0)
        Next
#End If
        UpdateDio()

#If USE_LEGACY_API Then
        dout = 0
        For i = 0 To MOT_MAX_DIO - 1
            If m_dout(i) = 0 Then
                dout = dout + (&H1 << i)
            End If
        Next
        p9016_set_do(m_curCardNo, dout)      '该接口设置的DOUT状态，0表示导通（低电平），1表示截止（高电平）
#Else
        dout = 0
        For i = 0 To MOT_MAX_DIO - 1
            If m_dout(i) <> 0 Then
                dout = dout + (&H1 << i)
            End If
        Next
        p9016_motion_set_dout_ex(m_curCardNo, dout) '该接口设置的DOUT状态，1表示导通，0表示截止
#End If

        'position comparator
        rc = p9016_cmp_get_status(m_curCardNo, 0, cmpStat)
        If rc = 0 Then
            TxtCmpMatchCount.Text = cmpStat.matchCount.ToString()
            '在更新控制轴状态时更新此状态值
            'TxtCmpActPos.Text = actPos.ToString()
            TxtCmpCurrentRef.Text = cmpStat.curRef.ToString()
            TxtCmpQueueEmpty.Text = IIf(cmpStat.queEmpty <> 0, "Y", "N")
            TxtCmpQueueFull.Text = IIf(cmpStat.queFull <> 0, "Y", "N")
            TxtCmpRefCount.Text = cmpStat.queItem.ToString()
        End If

        'show version number
        LblAppVer.Text = g_AppVersionStr

#If USE_LEGACY_API Then
        p9016_get_version(m_curCardNo, Ver(0), Ver(1), Ver(2))
        lblApiVer.Text = "0x" & Ver(0).ToString("x4")
        LblDriverVer.Text = "0x" & Ver(1).ToString("x4")
        LblLogicVer.Text = "0x" & Ver(2).ToString("x4")
#Else
        p9016_motion_get_info(m_curCardNo, info, 8)
        lblApiVer.Text = "0x" & info(6).ToString("x4")
        LblDriverVer.Text = "0x" & info(5).ToString("x4")
        LblLogicVer.Text = "0x" & info(4).ToString("x4")
#End If
    End Sub

    Sub UpdateDio()
        Dim ChkDIs() As CheckBox = {ChkDI0, ChkDI1, ChkDI2, ChkDI3, ChkDI4, ChkDI5, ChkDI6, ChkDI7, _
        ChkDI8, ChkDI9, ChkDI10, ChkDI11, ChkDI12, ChkDI13, ChkDI14, ChkDI15}

        Dim ChkDOs() As CheckBox = {ChkDO0, ChkDO1, ChkDO2, ChkDO3, ChkDO4, ChkDO5, ChkDO6, ChkDO7, _
        ChkDO8, ChkDO9, ChkDO10, ChkDO11, ChkDO12, ChkDO13, ChkDO14, ChkDO15}

        Dim i As Integer
        For i = 0 To MOT_MAX_DIO - 1
            ChkDIs(i).Checked = IIf((m_din(i) <> 0), True, False)
            m_dout(i) = IIf(ChkDOs(i).Checked, 1, 0)
        Next
    End Sub
#End Region

#Region "控制轴运动页面处理"
    ''' <summary>
    ''' 控制轴运动页面获取选中的控制轴
    ''' </summary>
    Private Function GetAxisSel() As Integer
        If RadAxisSel0.Checked Then
            Return m_curCardNo * AXES_PER_DEV + 0
        ElseIf RadAxisSel1.Checked Then
            Return m_curCardNo * AXES_PER_DEV + 1
        ElseIf RadAxisSel2.Checked Then
            Return m_curCardNo * AXES_PER_DEV + 2
        ElseIf RadAxisSel3.Checked Then
            Return m_curCardNo * AXES_PER_DEV + 3
        ElseIf RadAxisSel4.Checked Then
            Return m_curCardNo * AXES_PER_DEV + 4
        Else
            Return m_curCardNo * AXES_PER_DEV + 5
        End If
    End Function
    ''' <summary>
    ''' 控制轴运动页面运行按钮
    ''' </summary>
    Private Sub BtnAxisRun_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnAxisRun.Click
        Dim minVel, maxVel, accel, decel As Double
        Dim axis, rc, pos1, pos2 As Integer

        pos1 = CInt(TxtAxisPos1.Text)
        pos2 = CInt(TxtAxisPos2.Text)
        minVel = CDbl(TxtAxisMinVel.Text)
        maxVel = CDbl(TxtAxisMaxVel.Text)
        accel = CDbl(TxtAxisAccel.Text)
        decel = CDbl(TxtAxisDecel.Text)

        axis = GetAxisSel()

        'donot change minvel/maxvel/accel/decel while operating cmdPos and fbPos
        If Not RadAxisSetCmdPos.Checked And Not RadAxisSetFbPos.Checked Then
#If USE_LEGACY_API Then
            'If NcConfig.AxisProfileType(axis) = 0 Then
            rc = p9016_set_t_profile(axis, minVel, maxVel, accel, decel)
            'Else
            '    rc = p9016_set_s_profile(axis, minVel, maxVel, accel, decel, NcConfig.AxisProfileJerkPercent(axis))
            'End If
#Else
            'donnot support s-curve
            rc = p9016_axis_set_profile(axis, minVel, maxVel, accel, decel, accel * 1000000.0)
#End If
        End If
        NcConfig.AxisMinVel(axis) = minVel
        NcConfig.AxisMaxVel(axis) = maxVel
        NcConfig.AxisAccel(axis) = accel
        NcConfig.AxisDecel(axis) = decel

        If RadAxisAbsJog.Checked Then
#If USE_LEGACY_API Then
            rc = p9016_pmove(axis, pos1, 1, 2)
#Else
            rc = p9016_axis_abs_move(axis, pos1)
#End If

        ElseIf RadAxisIncrJog.Checked Then
#If USE_LEGACY_API Then
            rc = p9016_pmove(axis, pos1, 0, 2)
#Else
            rc = p9016_axis_incr_move(axis, pos1)
#End If

        ElseIf RadAxisJogPos.Checked Then
#If USE_LEGACY_API Then
            rc = p9016_vmove(axis, 1, 2)
#Else
            rc = p9016_axis_cont_move(axis, Math.Abs(maxVel))
#End If

        ElseIf RadAxisJogNeg.Checked Then
#If USE_LEGACY_API Then
            rc = p9016_vmove(axis, 0, 2)
#Else
            rc = p9016_axis_cont_move(axis, -1.0 * Math.Abs(maxVel))
#End If

        ElseIf RadAxisHomePos.Checked Then
#If USE_LEGACY_API Then
            rc = p9016_home_move(axis, 1)
#Else
            rc = p9016_axis_home(axis, Math.Abs(maxVel), NcConfig.AxisHomeMode(axis))
#End If

        ElseIf RadAxisHomeNeg.Checked Then
#If USE_LEGACY_API Then
            rc = p9016_home_move(axis, 0)
#Else
            rc = p9016_axis_home(axis, -1 * Math.Abs(maxVel), NcConfig.AxisHomeMode(axis))
#End If

        ElseIf RadAxisRepeatMove.Checked Then
            If Not m_AxisRepeatMove(axis) Then
                rc = p9016_pmove(axis, pos1, 1, 2)
                m_AxisJogPos1(axis) = pos1
                m_AxisJogPos2(axis) = pos2
                m_AxisRepeatMove(axis) = True

            End If
        ElseIf RadAxisSetCmdPos.Checked Then
#If USE_LEGACY_API Then
            rc = p9016_set_pos(axis, 0, pos1)
#Else
            rc = p9016_axis_set_cmd_pos(axis, pos1)
#End If

        ElseIf RadAxisSetFbPos.Checked Then
#If USE_LEGACY_API Then
            rc = p9016_set_pos(axis, 1, pos1)
#Else
            rc = p9016_axis_set_act_pos(axis, pos1)
#End If

        End If

        If rc <> 0 Then
            MsgBox("发送命令失败(" & rc.ToString() & "-" & GetErrorString(rc) & ")", MsgBoxStyle.Information, "错误提示")
        End If
    End Sub

    Private Sub BtnAxisAbort_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnAxisAbort.Click
        Dim axis As Integer

        axis = GetAxisSel()
        If m_AxisRepeatMove(axis) Then
            m_AxisRepeatMove(axis) = False
        End If

#If USE_LEGACY_API Then
        p9016_stop(axis, 0)
#Else
        p9016_axis_abort(axis)
#End If

    End Sub

    ''' <summary>
    ''' 切换控制轴时自动切换参数
    ''' </summary>
    Private Sub RadAxisSel_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadAxisSel0.CheckedChanged, RadAxisSel1.CheckedChanged, RadAxisSel2.CheckedChanged, RadAxisSel3.CheckedChanged
        AxisUpdateDlg()
    End Sub
    ''' <summary>
    ''' 控制轴运动页面自动更新参数，切换卡号/控制轴时调用
    ''' </summary>
    Private Sub AxisUpdateDlg()
        Dim axis As Integer

        axis = GetAxisSel()
        If axis < 0 Then
            Return
        End If

        TxtAxisPos1.Text = m_AxisJogPos1(axis).ToString()
        TxtAxisPos2.Text = m_AxisJogPos2(axis).ToString()
        TxtAxisMinVel.Text = NcConfig.AxisMinVel(axis).ToString("f1")
        TxtAxisMaxVel.Text = NcConfig.AxisMaxVel(axis).ToString("f1")
        TxtAxisAccel.Text = NcConfig.AxisAccel(axis).ToString("f1")
        TxtAxisDecel.Text = NcConfig.AxisDecel(axis).ToString("f1")
    End Sub

    Private Sub RadAxisRepeatMove_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadAxisRepeatMove.CheckedChanged
        If RadAxisRepeatMove.Checked Then
            TxtAxisPos2.Enabled = True
            LabelAxisPos2.Enabled = True
        Else
            TxtAxisPos2.Enabled = False
            LabelAxisPos2.Enabled = True
        End If
    End Sub

    Private Sub BtnAxisServoONToggle_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnAxisServoONToggle.Click
        Dim axis As Integer

        axis = GetAxisSel()
        If axis < 0 Then
            Return
        End If

        NcConfig.AxisServoON(axis) = IIf(NcConfig.AxisServoON(axis) <> 0, 0, 1)
        'p9016_axis_set_servo_on(axis, NcConfig.AxisServoON(axis))
    End Sub
    ''' <summary>
    ''' 将错误码转换为字符串
    ''' </summary>
    Private Function GetErrorString(ByVal err As Integer) As String
        If err = 1 Then
            Return "无效参数"
        ElseIf err = 2 Then
            Return "分配系统资源失败"
        ElseIf err = 7 Then
            Return "无法访问驱动程序"
        ElseIf err = 12 Then
            Return "设备已经打开"

        ElseIf err = 201 Then
            Return "无法识别的运动错误"
        ElseIf err = 202 Then
            Return "控制轴忙"
        ElseIf err = 205 Then
            Return "控制轴限位或告警有效"
        Else
            Return ""
        End If
    End Function

#End Region

#Region "配置界面处理"
    ''' <summary>
    ''' 获取配置标签页选中的控制轴
    ''' </summary>
    Private Function CfgGetAxisSel() As Integer
        If RadCfgAxisSel0.Checked Then
            Return m_curCardNo * AXES_PER_DEV + 0
        ElseIf RadCfgAxisSel1.Checked Then
            Return m_curCardNo * AXES_PER_DEV + 1
        ElseIf RadCfgAxisSel2.Checked Then
            Return m_curCardNo * AXES_PER_DEV + 2
        ElseIf RadCfgAxisSel3.Checked Then
            Return m_curCardNo * AXES_PER_DEV + 3
        ElseIf RadCfgAxisSel4.Checked Then
            Return m_curCardNo * AXES_PER_DEV + 4
        Else
            Return m_curCardNo * AXES_PER_DEV + 5
        End If
    End Function
    ''' <summary>
    ''' 参数设置标签页更新界面显示
    ''' </summary>
    Private Sub CfgUpateDlg()
        Dim axis As Integer

        axis = CfgGetAxisSel()

        RadAxisOutputPulDir.Checked = IIf(NcConfig.AxisOutputMode(axis) = 0, True, False)
        RadAxisOutputCwCcw.Checked = IIf(NcConfig.AxisOutputMode(axis) = 1, True, False)

        RadOutputInvDisable.Checked = IIf(NcConfig.AxisOutputDirInv(axis) = 0, True, False)
        RadOutputInvEnable.Checked = IIf(NcConfig.AxisOutputDirInv(axis) = 1, True, False)

        RadAxisInputPulDir.Checked = IIf(NcConfig.AxisInputMode(axis) = 0, True, False)
        RadAxisInputQuadrature.Checked = IIf(NcConfig.AxisInputMode(axis) = 1, True, False)

        RadInputInvDisable.Checked = IIf(NcConfig.AxisInputDirInv(axis) = 0, True, False)
        RadInputInvEnable.Checked = IIf(NcConfig.AxisInputDirInv(axis) = 1, True, False)

        RadPHLNormalOpen.Checked = IIf(NcConfig.AxisPelType(axis) = 0, True, False)
        RadPHLNormalClose.Checked = IIf(NcConfig.AxisPelType(axis) = 1, True, False)

        RadPHLEnable.Checked = IIf(NcConfig.AxisPelEnable(axis) = 1, True, False)
        RadPHLDisable.Checked = IIf(NcConfig.AxisPelEnable(axis) = 0, True, False)
        'Setting NHL type is not supported

        RadNHLEnable.Checked = IIf(NcConfig.AxisNelEnable(axis) = 1, True, False)
        RadNHLDisable.Checked = IIf(NcConfig.AxisNelEnable(axis) = 0, True, False)

        RadFaultDisable.Checked = IIf(NcConfig.AxisFaultEnable(axis) = 0, True, False)
        RadFaultEnable.Checked = IIf(NcConfig.AxisFaultEnable(axis) = 1, True, False)
        RadFaultNormalOpen.Checked = IIf(NcConfig.AxisFaultType(axis) = 0, True, False)
        RadFaultNormalClose.Checked = IIf(NcConfig.AxisFaultType(axis) = 1, True, False)

        RadHomeOnly.Checked = IIf(NcConfig.AxisHomeMode(axis) = 0, True, False)
        RadHomeAndIndex.Checked = IIf(NcConfig.AxisHomeMode(axis) = 1, True, False)

        RadHomeSwNormalOpen.Checked = IIf(NcConfig.AxisHomeSwType(axis) = 0, True, False)
        RadHomeSwNormalClose.Checked = IIf(NcConfig.AxisHomeSwType(axis) = 1, True, False)

        RadIndexRisingEdge.Checked = IIf(NcConfig.AxisIndexPolarity(axis) = 1, True, False)
        RadIndexFallingEdge.Checked = IIf(NcConfig.AxisIndexPolarity(axis) = 0, True, False)

        'RadAxisProfileT.Checked = IIf(NcConfig.AxisProfileType(axis) = 0, True, False)
        'RadAxisProfileS.Checked = IIf(NcConfig.AxisProfileType(axis) = 1, True, False)
        'TxtAxisJerkPercent.Text = NcConfig.AxisProfileJerkPercent(axis).ToString("f1")

        '更新比较器显示状态
        RadCmpEnable.Checked = IIf(NcConfig.CmpEnable(m_curCardNo) <> 0, True, False)
        RadCmpDisable.Checked = IIf(NcConfig.CmpEnable(m_curCardNo) = 0, True, False)

        TxtCmpOutLength.Text = NcConfig.CmpOutLength(m_curCardNo).ToString()

        RadCmpOutLevelHigh.Checked = IIf(NcConfig.CmpOutActiveLevel(m_curCardNo) <> 0, True, False)
        RadCmpOutLevelLow.Checked = IIf(NcConfig.CmpOutActiveLevel(m_curCardNo) = 0, True, False)

        RadCmpRefSource0.Checked = IIf(NcConfig.CmpRefSource(m_curCardNo) = 0, True, False)
        RadCmpRefSource1.Checked = IIf(NcConfig.CmpRefSource(m_curCardNo) = 1, True, False)
        RadCmpRefSource2.Checked = IIf(NcConfig.CmpRefSource(m_curCardNo) = 2, True, False)
        RadCmpRefSource3.Checked = IIf(NcConfig.CmpRefSource(m_curCardNo) = 3, True, False)
    End Sub
    ''' <summary>
    ''' 更新DI/DO界面，卡号更改后调用
    ''' </summary>
    Private Sub DioUpdateDlg()
        Dim ChkDOs() As CheckBox = {ChkDO0, ChkDO1, ChkDO2, ChkDO3, ChkDO4, ChkDO5, ChkDO6, ChkDO7, _
                                    ChkDO8, ChkDO9, ChkDO10, ChkDO11, ChkDO12, ChkDO13, ChkDO14, ChkDO15}
        Dim d As UInteger
        Dim i, rc As Integer
#If USE_LEGACY_API Then
        rc = p9016_get_do(m_curCardNo, d)
        If rc <> 0 Then
            Return
        End If
        'legacy DI/DO API state definition: 0 for ON, 1 for OFF
        For i = 0 To MOT_MAX_DIO - 1
            ChkDOs(i).Checked = IIf((d And (&H1 << i)) = 0, True, False)
        Next
#Else
        rc = p9016_motion_get_dout_ex(m_curCardNo, d)
        If rc <> 0 Then
            Return
        End If
        'pcie9014 DI/DO state definition: 1 for ON, 0 for OFF
        For i = 0 To MOT_MAX_DIO - 1
            ChkDOs(i).Checked = IIf((d And (&H1 << i)) <> 0, True, False)
        Next
#End If

    End Sub

    Private Sub RadCfgAxisSel_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadCfgAxisSel0.CheckedChanged, RadCfgAxisSel1.CheckedChanged, RadCfgAxisSel2.CheckedChanged, RadCfgAxisSel3.CheckedChanged
        Dim axis As Integer

        axis = CfgGetAxisSel()
        If axis < 4 Then
            GroupBoxCfgIndexPolarity.Enabled = True
            RadHomeAndIndex.Enabled = True
        Else
            GroupBoxCfgIndexPolarity.Enabled = False
            RadHomeAndIndex.Enabled = False
        End If
        CfgUpateDlg()
    End Sub
    ''' <summary>
    ''' 配置标签页保存参数并配置控制轴
    ''' </summary>
    Private Sub BtnCfgApply_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnCfgApply.Click
        Dim axis As Integer

        axis = CfgGetAxisSel()

        If RadAxisOutputPulDir.Checked Then
            NcConfig.AxisOutputMode(axis) = 0
        Else 'RadAxisOutputCwCcw.Checked Then
            NcConfig.AxisOutputMode(axis) = 1
            'Else
            ' NcConfig.AxisOutputMode(axis) = 2
        End If

        NcConfig.AxisOutputDirInv(axis) = IIf(RadOutputInvEnable.Checked, 1, 0)
        NcConfig.AxisInputMode(axis) = IIf(RadAxisInputPulDir.Checked, 0, 1)
        NcConfig.AxisInputDirInv(axis) = IIf(RadInputInvEnable.Checked, 1, 0)

        'PEL
        If RadPHLNormalClose.Checked Then
            NcConfig.AxisPelType(axis) = 1
        Else
            NcConfig.AxisPelType(axis) = 0
        End If

        NcConfig.AxisPelEnable(axis) = IIf(RadPHLEnable.Checked, 1, 0)
        'If RadNHLNormalClose.Checked Then
        '    NcConfig.AxisNelType(axis) = 1
        'Else
        '    NcConfig.AxisNelType(axis) = 0
        'End If
        NcConfig.AxisNelEnable(axis) = IIf(RadNHLEnable.Checked, 1, 0)

        'FAULT
        If RadFaultEnable.Checked Then
            NcConfig.AxisFaultEnable(axis) = 1
        Else
            NcConfig.AxisFaultEnable(axis) = 0
        End If

        If RadFaultNormalClose.Checked Then
            NcConfig.AxisFaultType(axis) = 1
        Else
            NcConfig.AxisFaultType(axis) = 0
        End If

        'home, index
        If RadHomeSwNormalClose.Checked Then
            NcConfig.AxisHomeSwType(axis) = 1
        Else
            NcConfig.AxisHomeSwType(axis) = 0
        End If

        If RadHomeAndIndex.Checked Then
            NcConfig.AxisHomeMode(axis) = 1
        Else
            NcConfig.AxisHomeMode(axis) = 0
        End If

        If RadIndexRisingEdge.Checked Then
            NcConfig.AxisIndexPolarity(axis) = 1
        Else
            NcConfig.AxisIndexPolarity(axis) = 0
        End If

        'NcConfig.AxisProfileType(axis) = IIf(RadAxisProfileT.Checked, 0, 1)
        'NcConfig.AxisProfileJerkPercent(axis) = CDbl(TxtAxisJerkPercent.Text)
        ''check parameter
        'If NcConfig.AxisProfileJerkPercent(axis) < 0.0 Then
        '    NcConfig.AxisProfileJerkPercent(axis) = 0.0
        'End If

        'If NcConfig.AxisProfileJerkPercent(axis) > 1.0 Then
        '    NcConfig.AxisProfileJerkPercent(axis) = 1.0
        'End If

        NcConfig.Save()
        ConfigAxis(axis)
    End Sub
    ''' <summary>
    ''' 配置控制轴参数
    ''' </summary>
    Sub ConfigAxis(ByVal axis As Integer)
        Dim rc As Integer
#If USE_LEGACY_API Then
        rc = p9016_set_pls_outmode(axis, NcConfig.AxisOutputMode(axis))
        rc = p9016_set_pls_iptmode(axis, NcConfig.AxisInputMode(axis))
        rc = p9016_set_el_level(axis, NcConfig.AxisPelType(axis))
        rc = p9016_set_alarm(axis, NcConfig.AxisFaultEnable(axis), NcConfig.AxisFaultType(axis))
        rc = p9016_home_config(axis, _
                                IIf(NcConfig.AxisHomeMode(axis) <> 0, 2, 0), _
                                NcConfig.AxisHomeSwType(axis), _
                                NcConfig.AxisIndexPolarity(axis))
#Else
        rc = p9016_axis_set_parameter(axis, PN_NUMBER.PN_OutputMode, NcConfig.AxisOutputMode(axis))
        rc = p9016_axis_set_parameter(axis, PN_NUMBER.PN_InvertOutputDirection, NcConfig.AxisOutputDirInv(axis))
        rc = p9016_axis_set_parameter(axis, PN_NUMBER.PN_InputMode, NcConfig.AxisInputMode(axis))
        rc = p9016_axis_set_parameter(axis, PN_NUMBER.PN_InvertInputDirection, NcConfig.AxisInputDirInv(axis))

        rc = p9016_axis_set_parameter(axis, PN_NUMBER.PN_PosLimitSwitchType, NcConfig.AxisPelType(axis))
        rc = p9016_axis_set_parameter(axis, PN_NUMBER.PN_PosLimitSwitchEnable, NcConfig.AxisPelEnable(axis))
        'rc = p9016_axis_set_parameter(axis, PN_NUMBER.PN_NegLimitSwitchType, NcConfig.AxisNelType(axis))       'not supported
        rc = p9016_axis_set_parameter(axis, PN_NUMBER.PN_NegLimitSwitchEnable, NcConfig.AxisNelEnable(axis))
        'rc = p9016_axis_set_parameter(axis, PN_NUMBER.PN_AmpFaultType, NcConfig.AxisFaultType(axis))
        'rc = p9016_axis_set_parameter(axis, PN_NUMBER.PN_AmpFaultEnable, NcConfig.AxisFaultEnable(axis))
        rc = p9016_axis_set_parameter(axis, PN_NUMBER.PN_HomeSwitchType, NcConfig.AxisHomeSwType(axis))
        rc = p9016_axis_set_parameter(axis, PN_NUMBER.PN_IndexActiveLevel, NcConfig.AxisIndexPolarity(axis))
#End If
    End Sub
#End Region
    'Private Sub CbCardNo_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CbCardNo.SelectedIndexChanged
    '    If CbCardNo.SelectedIndex < 0 Then
    '        Return
    '    End If

    '    m_curCardNo = m_cardIds(CbCardNo.SelectedIndex)

    '    DioUpdateDlg()
    '    CfgUpateDlg()
    '    AxisUpdateDlg()
    'End Sub

    Private Sub ToolStripMenuItemAbout_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripMenuItemAbout.Click
        Dim dlg As New AboutBox1
        dlg.ShowDialog()
    End Sub

    '使用菜单项来选择控制卡卡号
    Private Sub ToolStripMenuItemDevSel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim sel As Integer

        sel = CInt(sender.ToString())
        Me.Text = "PCI-9016#" + sender.ToString()

        m_curCardNo = m_cardIds(sel)

        DioUpdateDlg()
        CfgUpateDlg()
        AxisUpdateDlg()
    End Sub

    Private Sub BtnCmpSetRef_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnCmpSetRef.Click
        Dim sValues() As String
        Dim separators() As String = {" ", vbTab, ",", ";"}
        Dim rc As Integer

        If NcConfig.CmpEnable(m_curCardNo) = 0 Then
            MsgBox("比较器未使能！")
            Return
        End If

        sValues = TxtCmpPosRef.Text.Split(separators, StringSplitOptions.RemoveEmptyEntries)
        For Each item As String In sValues
            rc = p9016_cmp_set_ref(m_curCardNo, 0, CInt(item))
            If rc <> 0 Then
                MsgBox("设置比较器参考值失败!(" + rc.ToString() + ")")
            End If
        Next

    End Sub


    Private Sub BtnCmpSetParam_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnCmpSetParam.Click
        Dim cmpEnable, cmpOutLen, cmpRefSource, cmpOutLevel, rc As Integer

        cmpEnable = IIf(RadCmpEnable.Checked, 1, 0)

        If RadCmpRefSource0.Checked Then
            cmpRefSource = 0
        ElseIf RadCmpRefSource1.Checked Then
            cmpRefSource = 1
        ElseIf RadCmpRefSource2.Checked Then
            cmpRefSource = 2
        Else
            cmpRefSource = 3
        End If
        cmpOutLen = CInt(TxtCmpOutLength.Text)
        cmpOutLevel = IIf(RadCmpOutLevelHigh.Checked, 1, 0)

        NcConfig.CmpOutLength(m_curCardNo) = cmpOutLen
        NcConfig.CmpRefSource(m_curCardNo) = cmpRefSource
        NcConfig.CmpOutActiveLevel(m_curCardNo) = cmpOutLevel
        NcConfig.CmpEnable(m_curCardNo) = cmpEnable

        rc = p9016_cmp_enable(m_curCardNo, 0, cmpEnable, cmpOutLevel, cmpRefSource, cmpOutLen)
        If rc <> 0 Then
            MsgBox("设置位置比较器失败(" & rc.ToString() & ")", MsgBoxStyle.Information, "错误提示")
        End If
    End Sub
End Class
